diff -c ../zip19i/zipfile.c ./zipfile.c
*** ../zip19i/zipfile.c	Tue Nov  3 21:07:58 1992
--- ./zipfile.c	Mon Sep  6 04:18:50 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 13,19 ****
--- 12,20 ----
   *  zipfile.c by Mark Adler.
   */
  
+ #define NOCPYRT         /* this is not a main module */
  #include "zip.h"
+ #include "revision.h"
  
  #ifdef VMS
  #  include "VMSmunch.h"
***************
*** 26,33 ****
  #define LG(a) ((ulg)SH(a) | ((ulg)SH((a)+2) << 16))
  
  /* Macros for writing machine integers to little-endian format */
! #define PUTSH(a,f) {putc((char)(a),(f)); putc((char)((a) >> 8),(f));}
! #define PUTLG(a,f) {PUTSH(a,f) PUTSH((a) >> 16,f)}
  
  
  /* -- Structure of a ZIP file -- */
--- 27,34 ----
  #define LG(a) ((ulg)SH(a) | ((ulg)SH((a)+2) << 16))
  
  /* Macros for writing machine integers to little-endian format */
! #define PUTSH(a,f) {putc((char)(a) & 0xff,(f)); putc((char)((a) >> 8),(f));}
! #define PUTLG(a,f) {PUTSH((a) & 0xffff,f) PUTSH((a) >> 16,f)}
  
  
  /* -- Structure of a ZIP file -- */
***************
*** 50,55 ****
--- 51,60 ----
  #define LOCNAM  22              /* length of filename */
  #define LOCEXT  24              /* length of extra field */
  
+ #define EXTCRC  0               /* uncompressed crc-32 for file */
+ #define EXTSIZ  4               /* compressed size in zip file */
+ #define EXTLEN  8               /* uncompressed size */
+ 
  #define CENVEM  0               /* version made by */
  #define CENVER  2               /* version needed to extract */
  #define CENFLG  4               /* encrypt, deflate flags */
***************
*** 78,93 ****
  
  /* Local functions */
  
! local int zqcmp OF((voidp *, voidp *));
  #  ifndef UTIL
!      local int rqcmp OF((voidp *, voidp *));
!      local int zbcmp OF((voidp *, voidp far *));
!      local char *cutpath OF((char *));
  #  endif /* !UTIL */
  
  
  local int zqcmp(a, b)
! voidp *a, *b;           /* pointers to pointers to zip entries */
  /* Used by qsort() to compare entries in the zfile list.
   * Compares the internal names z->zname */
  {
--- 83,98 ----
  
  /* Local functions */
  
! local int zqcmp OF((const voidp *, const voidp *));
  #  ifndef UTIL
!      local int rqcmp OF((const voidp *, const voidp *));
!      local int zbcmp OF((const voidp *, const voidp far *));
!      local void cutpath OF((char *p));
  #  endif /* !UTIL */
  
  
  local int zqcmp(a, b)
! const voidp *a, *b;           /* pointers to pointers to zip entries */
  /* Used by qsort() to compare entries in the zfile list.
   * Compares the internal names z->zname */
  {
***************
*** 98,104 ****
  #ifndef UTIL
  
  local int rqcmp(a, b)
! voidp *a, *b;           /* pointers to pointers to zip entries */
  /* Used by qsort() to compare entries in the zfile list.
   * Compare the internal names z->zname, but in reverse order. */
  {
--- 103,109 ----
  #ifndef UTIL
  
  local int rqcmp(a, b)
! const voidp *a, *b;           /* pointers to pointers to zip entries */
  /* Used by qsort() to compare entries in the zfile list.
   * Compare the internal names z->zname, but in reverse order. */
  {
***************
*** 108,115 ****
  
  
  local int zbcmp(n, z)
! voidp *n;               /* string to search for */
! voidp far *z;           /* pointer to a pointer to a zip entry */
  /* Used by search() to compare a target to an entry in the zfile list. */
  {
    return namecmp((char *)n, ((struct zlist far *)z)->zname);
--- 113,120 ----
  
  
  local int zbcmp(n, z)
! const voidp *n;         /* string to search for */
! const voidp far *z;     /* pointer to a pointer to a zip entry */
  /* Used by search() to compare a target to an entry in the zfile list. */
  {
    return namecmp((char *)n, ((struct zlist far *)z)->zname);
***************
*** 147,162 ****
    if ((t = malloc(strlen(s) + 5)) == NULL)
      return NULL;
    strcpy(t, s);
  #ifdef MSDOS
    for (q = t; *q; q++)
      if (*q == '\\')
        *q = '/';
  #endif /* MSDOS */
    if (strrchr((q = strrchr(t, PATHCUT)) == NULL ? t : q + 1, '.') == NULL)
      strcat(t, ".zip");
- #if defined(FORCE_UPPER) && defined(MSDOS) && !defined(OS2)
-   strupr(t);
- #endif
    return t;
  }
  
--- 152,173 ----
    if ((t = malloc(strlen(s) + 5)) == NULL)
      return NULL;
    strcpy(t, s);
+ #ifdef __human68k__
+   _toslash(t);
+ #endif
  #ifdef MSDOS
    for (q = t; *q; q++)
      if (*q == '\\')
        *q = '/';
  #endif /* MSDOS */
+ #ifdef AMIGA
+   if ((q = strrchr(t, '/')) == NULL)
+     q = strrchr(t, ':');
+   if (strrchr((q ? q + 1 : t), '.') == NULL)
+ #else /* !AMIGA */
    if (strrchr((q = strrchr(t, PATHCUT)) == NULL ? t : q + 1, '.') == NULL)
+ #endif /* ?AMIGA */
      strcat(t, ".zip");
    return t;
  }
  
***************
*** 230,235 ****
--- 241,247 ----
     Return an error code in the ZE_ class.
  */
  {
+   ulg a = 0L;           /* attributes returned by filetime() */
    char b[CENHEAD];      /* buffer for central headers */
    FILE *f;              /* zip file */
    ush flg;              /* general purpose bit flag */
***************
*** 270,275 ****
--- 282,294 ----
        (f = fopen(zipfile, FOPR)) != NULL)
  #endif /* ?VMS */
    {
+     /* Get any file attribute valid for this OS, to set in the central
+      * directory when fixing the archive:
+      */
+ #ifndef UTIL
+     if (fix)
+       filetime(zipfile, &a, (long*)&s);
+ #endif
      x = &zfiles;                        /* first link */
      p = 0;                              /* starting file offset */
      zcount = 0;                         /* number of files */
***************
*** 294,319 ****
           be greater than or equal to LOCHEAD) */
        if ((z = (struct zlist far *)farmalloc(sizeof(struct zlist))) == NULL)
          return ZE_MEM;
!       if (fread(b, LOCHEAD, 1, f) != 1)
!         return ferror(f) ? ZE_READ : ZE_EOF;
!       t = b;  u = (char far *)z;  n = LOCHEAD;
!       do {
!         *u++ = *t++;
!       } while (--n);
! 
        /* Link into list */
        *x = z;
        z->nxt = NULL;
        x = &z->nxt;
  
        /* Read file name and extra field and skip data */
-       n = SH(LOCNAM + (uch far *)z);
-       z->ext = SH(LOCEXT + (uch far *)z);
- #ifdef ZIPFIX
-       s = 0;
- #else
-       s = LG(LOCSIZ + (uch far *)z);
- #endif
        if (n == 0)
        {
          sprintf(errbuf, "%d", zcount + 1);
--- 313,359 ----
           be greater than or equal to LOCHEAD) */
        if ((z = (struct zlist far *)farmalloc(sizeof(struct zlist))) == NULL)
          return ZE_MEM;
!       if (fread(b, LOCHEAD, 1, f) != 1) {
!         if (fix)
!           break;
!         else
!           return ferror(f) ? ZE_READ : ZE_EOF;
!       }
!       if (fix) {
!         z->ver = SH(LOCVER + b);
!         z->vem = dosify ? 20 : OS_CODE + REVISION;
!         z->dosflag = dosify;
!         flg = z->flg = z->lflg = SH(LOCFLG + b);
!         z->how = SH(LOCHOW + b);
!         z->tim = LG(LOCTIM + b);          /* time and date into one long */
!         z->crc = LG(LOCCRC + b);
!         z->siz = LG(LOCSIZ + b);
!         z->len = LG(LOCLEN + b);
!         n = z->nam = SH(LOCNAM + b);
!         z->cext = z->ext = SH(LOCEXT + b);
!         z->com = 0;
!         z->dsk = 0;
!         z->att = 0;
!         z->atx = dosify ? a & 0xff : a;     /* Attributes from filetime() */
!         z->mark = 0;
!         z->trash = 0;
!         s = fix > 1 ? 0L : z->siz; /* discard compressed size with -FF */
!       } else {
!         t = b;  u = (char far *)z;  n = LOCHEAD;
!         do {
!           *u++ = *t++;
!         } while (--n);
!         z->ext = SH(LOCEXT + (uch far *)z);
!         n = SH(LOCNAM + (uch far *)z);
!         flg = SH(b+LOCFLG);
!         s = LG(LOCSIZ + (uch far *)z);
!       }
        /* Link into list */
        *x = z;
        z->nxt = NULL;
        x = &z->nxt;
  
        /* Read file name and extra field and skip data */
        if (n == 0)
        {
          sprintf(errbuf, "%d", zcount + 1);
***************
*** 333,338 ****
--- 373,382 ----
         * the correct compressed size.
         */
        z->zname[n] = 0;                  /* terminate name */
+       if (fix) {
+         z->cextra = z->extra;
+         if (noisy) fprintf(mesg, "zip: reading %s\n", z->zname);
+       }
  #ifdef UTIL
        z->name = z->zname;               /* !!! to be checked */
  #else /* !UTIL */
***************
*** 347,354 ****
        zcount++;
  
        /* Skip extended local header if there is one */
-       flg = SH(b+LOCFLG);
- 
        if ((flg & 8) != 0) {
          /* Skip the compressed data if compressed size is unknown.
           * For safety, we should use the central directory.
--- 391,396 ----
***************
*** 362,368 ****
              if (fseek(f, -15L, SEEK_CUR))
                return ferror(f) ? ZE_READ : ZE_EOF;
            }
!           s = LG(b+8);
            p += s;
            if ((ulg) ftell(f) != p+16L) {
              warn("bad extended local header for ", z->zname);
--- 404,410 ----
              if (fseek(f, -15L, SEEK_CUR))
                return ferror(f) ? ZE_READ : ZE_EOF;
            }
!           s = LG(4 + EXTSIZ + b);
            p += s;
            if ((ulg) ftell(f) != p+16L) {
              warn("bad extended local header for ", z->zname);
***************
*** 380,420 ****
            }
          }
          /* overwrite the unknown values of the local header: */
!         t = b+4;  u = (char far *)z+LOCCRC;  n = 12;
!         do {
!           *u++ = *t++;
!         } while (--n);
          p += 16L;
        }
! #ifdef ZIPFIX
!       /* Don't trust the compressed size */
!       else {
! 	for (;;) {
! 	  while ((m = getc(f)) != EOF && m != 'P') p++;
! 	  b[0] = (char) m;
! 	  if (fread(b+1, 3, 1, f) != 1 || (s = LG(b)) == LOCSIG || s == CENSIG)
! 	    break;
! 	  if (fseek(f, -3L, SEEK_CUR))
! 	    return ferror(f) ? ZE_READ : ZE_EOF;
! 	  p++;
! 	}
! 	s = p - (z->off + 4 + LOCHEAD + n + z->ext);
! 	if (s != LG(LOCSIZ + (uch far *)z)) {
! 	  fprintf(stderr, " compressed size %ld, actual size %ld for %s\n",
! 		  LG(LOCSIZ + (uch far *)z), s, z->zname);
! 	}
        }
! #else
        /* Read next signature */
!       if (fread(b, 4, 1, f) != 1)
!         return ferror(f) ? ZE_READ : ZE_EOF;
! #endif /* ZIPFIX */
      }
  
      /* Point to start of header list and read central headers */
      z = zfiles;
      s = p;                              /* save start of central */
!     while (LG(b) == CENSIG)
      {
        if (z == NULL)
        {
--- 422,486 ----
            }
          }
          /* overwrite the unknown values of the local header: */
!         if (fix) {
!             /* already in host format */
!             z->crc = LG(4 + EXTCRC + b);
!             z->siz = s;
!             z->len = LG(4 + EXTLEN + b);
!         } else {
!             /* Keep in Intel format for comparison with central header */
!             t = b+4;  u = (char far *)z+LOCCRC;  n = 12;
!             do {
!               *u++ = *t++;
!             } while (--n);
!         }
          p += 16L;
        }
!       else if (fix > 1) {
!         /* Don't trust the compressed size */
!         for (;;) {
!           while ((m = getc(f)) != EOF && m != 'P') p++;
!           b[0] = (char) m;
!           if (fread(b+1, 3, 1, f) != 1 || (s = LG(b)) == LOCSIG || s == CENSIG)
!             break;
!           if (fseek(f, -3L, SEEK_CUR))
!             return ferror(f) ? ZE_READ : ZE_EOF;
!           p++;
!         }
!         s = p - (z->off + 4 + LOCHEAD + n + z->ext);
!         if (s != z->siz) {
!           fprintf(stderr, " compressed size %ld, actual size %ld for %s\n",
!                   z->siz, s, z->zname);
!           z->siz = s;
!         }
!         /* next LOCSIG already read at this point, don't read it again: */
!         continue;
        }
! 
        /* Read next signature */
!       if (fread(b, 4, 1, f) != 1) {
!         if (fix)
!           break;
!         else
!           return ferror(f) ? ZE_READ : ZE_EOF;
!       }
      }
  
      /* Point to start of header list and read central headers */
      z = zfiles;
      s = p;                              /* save start of central */
!     if (fix) {
!       if (LG(b) != CENSIG && noisy) {
!         fprintf(mesg, "zip warning: %s %s truncated.\n", zipfile,
!                 fix > 1 ? "has been" : "would be");
! 
!         if (fix == 1) {
!           fprintf(mesg,
!    "Retry with option -qF to truncate, with -FF to attempt full recovery\n");
!           err(ZE_FORM, NULL);
!         }
!       }
!     } else while (LG(b) == CENSIG)
      {
        if (z == NULL)
        {
***************
*** 437,448 ****
        for (m = 0, u = (char far *)z, n = 0; n < LOCHEAD - 2; n++)
          if (u[n] != b[n+2])
          {
!           if (!m)
              warn("local and central headers differ for ", z->zname);
            m = 1;
            sprintf(errbuf, " offset %d--local = %02x, central = %02x",
                    n, (uch)u[n], (uch)b[n+2]);
!           warn(errbuf, "");
          }
        if (m)
          return ZE_FORM;
--- 503,515 ----
        for (m = 0, u = (char far *)z, n = 0; n < LOCHEAD - 2; n++)
          if (u[n] != b[n+2])
          {
!           if (!m && noisy)
              warn("local and central headers differ for ", z->zname);
            m = 1;
            sprintf(errbuf, " offset %d--local = %02x, central = %02x",
                    n, (uch)u[n], (uch)b[n+2]);
!           if (noisy) warn(errbuf, "");
!           b[n+2] = u[n]; /* fix the zipfile */
          }
        if (m)
          return ZE_FORM;
***************
*** 463,468 ****
--- 530,536 ----
        z->dsk = SH(CENDSK + b);
        z->att = SH(CENATT + b);
        z->atx = LG(CENATX + b);
+       z->dosflag = (z->vem & 0xff00) == 0;
        if (z->off != LG(CENOFF + b))
        {
          warn("local offset in central header incorrect for ", z->zname);
***************
*** 590,624 ****
      }
      
      /* Read end header */
!     if (z != NULL || LG(b) != ENDSIG)
!     {
!       warn("missing end signature--probably not a zip file (did you", "");
!       warn("remember to use binary mode when you transferred it?)", "");
!       return ZE_FORM;
!     }
!     if (fread(b, ENDHEAD, 1, f) != 1)
!       return ferror(f) ? ZE_READ : ZE_EOF;
!     if (SH(ENDDSK + b) || SH(ENDBEG + b) ||
!         SH(ENDSUB + b) != SH(ENDTOT + b))
!       warn("multiple disk information ignored", "");
!     if (zcount != SH(ENDSUB + b))
!     {
!       warn("count in end of central directory incorrect", "");
!       return ZE_FORM;
!     }
!     if (LG(ENDSIZ + b) != p - s)
!     {
!       warn("central directory size is incorrect (made by stzip?)", "");
!       /* stzip 0.9 gets this wrong, so be tolerant */
!       /* return ZE_FORM; */
!     }
!     if (LG(ENDOFF + b) != s)
!     {
!       warn("central directory start is incorrect", "");
!       return ZE_FORM;
      }
      cenbeg = s;
!     zcomlen = SH(ENDCOM + b);
      if (zcomlen)
      {
        if ((zcomment = malloc(zcomlen)) == NULL)
--- 658,694 ----
      }
      
      /* Read end header */
!     if (!fix) {
!       if (z != NULL || LG(b) != ENDSIG)
!       {
!         warn("missing end signature--probably not a zip file (did you", "");
!         warn("remember to use binary mode when you transferred it?)", "");
!         return ZE_FORM;
!       }
!       if (fread(b, ENDHEAD, 1, f) != 1)
!         return ferror(f) ? ZE_READ : ZE_EOF;
!       if (SH(ENDDSK + b) || SH(ENDBEG + b) ||
!           SH(ENDSUB + b) != SH(ENDTOT + b))
!         warn("multiple disk information ignored", "");
!       if (zcount != SH(ENDSUB + b))
!       {
!         warn("count in end of central directory incorrect", "");
!         return ZE_FORM;
!       }
!       if (LG(ENDSIZ + b) != p - s)
!       {
!         warn("central directory size is incorrect (made by stzip?)", "");
!         /* stzip 0.9 gets this wrong, so be tolerant */
!         /* return ZE_FORM; */
!       }
!       if (LG(ENDOFF + b) != s)
!       {
!         warn("central directory start is incorrect", "");
!         return ZE_FORM;
!       }
      }
      cenbeg = s;
!     zcomlen = fix ? 0 : SH(ENDCOM + b);
      if (zcomlen)
      {
        if ((zcomment = malloc(zcomlen)) == NULL)
***************
*** 634,640 ****
        sprintf(errbuf, " has a preamble of %ld bytes", zipbeg);
        warn(zipfile, errbuf);
      }
!     if (getc(f) != EOF)
        warn("garbage at end of zip file ignored", "");
  
      /* Done with zip file for now */
--- 704,710 ----
        sprintf(errbuf, " has a preamble of %ld bytes", zipbeg);
        warn(zipfile, errbuf);
      }
!     if (!fix && getc(f) != EOF)
        warn("garbage at end of zip file ignored", "");
  
      /* Done with zip file for now */
***************
*** 723,729 ****
  
  int putend(n, s, c, m, z, f)
  int n;                  /* number of entries in central directory */
! ulg s, c;               /* size and offset of central directory */
  extent m;               /* length of zip file comment (0 if none) */
  char *z;                /* zip file comment if m != 0 */
  FILE *f;                /* file to write to */
--- 793,800 ----
  
  int putend(n, s, c, m, z, f)
  int n;                  /* number of entries in central directory */
! ulg s;                  /* size of central directory */
! ulg c;                  /* offset of central directory */
  extent m;               /* length of zip file comment (0 if none) */
  char *z;                /* zip file comment if m != 0 */
  FILE *f;                /* file to write to */
***************
*** 746,842 ****
  
  #ifndef UTIL
  
! local char *cutpath(p)
  char *p;                /* path string */
! /* Cut the last path component off the name *p in place.  Return p.
!  * For a directory name ending with /, just remove the /.
!  * For VMS, keep directory names intact. This function can be called
!  * on both internal names a/b and external names [a.b].
   */
  {
!   char *r;                   /* pointer to last path delimiter */
  
! #ifdef VMS                   /* change [w.x.y]z to [w.x.y] */
    if ((r = strrchr(p, ']')) != NULL)
    {
!     if (r[1] == '\0')
!       return p;              /* keep directory name intact */
!     r[1] = '\0';             /* [w.x.y]z -> [w.x.y] */
    }
!   else
! #endif /* VMS */             /* change w/x/y/z to w/x/y */
    if ((r = strrchr(p, '/')) != NULL)
      *r = 0;
    else
      *p = 0;
-   return p;
  }
  
- 
  int trash()
  /* Delete the compressed files and the directories that contained the deleted
     files, if empty.  Return an error code in the ZE_ class.  Failure of
     destroy() or deletedir() is ignored. */
  {
    extent i;             /* counter on deleted names */
!   extent n;             /* number of deleted names left to handle */
    struct zlist far **s; /* table of zip entries to handle, sorted */
    struct zlist far *z;  /* current zip entry */
  
!   /* Count and delete marked names */
    n = 0;
    for (z = zfiles; z != NULL; z = z->nxt)
      if (z->mark || z->trash)
      {
        z->mark = 1;
-       n++;
        if (z->zname[z->nam - 1] != '/') { /* don't unlink directory */
          if (verbose)
            fprintf(mesg, "zip diagnostic: trashing file %s\n", z->name);
          destroy(z->name);
        }
      }
  
!   /* Try to delete all paths that lead up to marked names */
    if (n)
    {
!     if ((s = (struct zlist far **)malloc((n+1)*sizeof(struct zlist far *))) ==
!         NULL ||
!         (s[0] = (struct zlist far *)farmalloc(sizeof(struct zlist))) == NULL)
        return ZE_MEM;
-     s[0]->name = s[0]->zname = "";
-     s++;
      n = 0;
!     for (z = zfiles; z != NULL; z = z->nxt)
!       if (z->mark && *cutpath(z->zname)) {
! 	cutpath(z->name);
!         if (strcmp(z->zname, s[n-1]->zname)) /* just to optimize qsort */
!           s[n++] = z;
      }
- 
      /* Sort the files in reverse order to get subdirectories first.
       * To avoid problems with strange naming conventions as in VMS,
       * we sort on the internal names, so x/y/z will always be removed
       * before x/y. On VMS, x/y/z > x/y but [x.y.z] < [x.y]
       */
- #ifdef VMS_BUG
-   printf("before qsort\n");
-   for (i = 0; i < n; i++) printf("%s\t%s\n", s[i]->zname, s[i]->name);
- #endif
      qsort((char *)s, n, sizeof(struct zlist far *), rqcmp);
! #ifdef VMS_BUG
!   printf("after qsort\n");
!   for (i = 0; i < n; i++) printf("%s\t%s\n", s[i]->zname, s[i]->name);
! #endif
!     for (i = 0; i < n; i++)
!       if (strcmp(s[i]->zname, s[i-1]->zname))
!       {
!         if (verbose)
            fprintf(mesg, "zip diagnostic: trashing directory %s (if empty)\n",
!                  s[i]->name);
          deletedir(s[i]->name);
        }
!     farfree((voidp far *)((--s)[0]));
      free((voidp *)s);
    }
    return ZE_OK;
--- 817,924 ----
  
  #ifndef UTIL
  
! local void cutpath(p)
  char *p;                /* path string */
! /* Cut the last path component off the name *p in place.
!  * This should work on both internal and external names.
   */
  {
!   char *r;              /* pointer to last path delimiter */
  
! #ifdef VMS                      /* change [w.x.y]z to [w.x]y.DIR */
    if ((r = strrchr(p, ']')) != NULL)
    {
!     *r = 0;
!     if ((r = strrchr(p, '.')) != NULL)
!     {
!       *r = ']';
!       strcat(r, ".DIR;1");     /* this assumes a little padding--see PAD */
!     } else {
!       *p = 0;
!     }
!   } else {
!     *p = 0;
    }
! #endif /* ?VMS */
    if ((r = strrchr(p, '/')) != NULL)
      *r = 0;
    else
      *p = 0;
  }
  
  int trash()
  /* Delete the compressed files and the directories that contained the deleted
     files, if empty.  Return an error code in the ZE_ class.  Failure of
     destroy() or deletedir() is ignored. */
  {
    extent i;             /* counter on deleted names */
!   extent n;             /* number of directories to delete */
    struct zlist far **s; /* table of zip entries to handle, sorted */
    struct zlist far *z;  /* current zip entry */
  
!   /* Delete marked names and count directories */
    n = 0;
    for (z = zfiles; z != NULL; z = z->nxt)
      if (z->mark || z->trash)
      {
        z->mark = 1;
        if (z->zname[z->nam - 1] != '/') { /* don't unlink directory */
          if (verbose)
            fprintf(mesg, "zip diagnostic: trashing file %s\n", z->name);
          destroy(z->name);
+         /* Try to delete all paths that lead up to marked names. This is
+          * necessary only without the -D option.
+          */
+         if (!dirnames) {
+           cutpath(z->name);
+           cutpath(z->zname);
+           if (z->zname[0] != '\0') {
+             strcat(z->zname, "/");
+           }
+           z->nam = strlen(z->zname);
+           if (z->nam > 0) n++;
+         }
+       } else {
+         n++;
        }
      }
  
!   /* Construct the list of all marked directories. Some may be duplicated
!    * if -D was used.
!    */
    if (n)
    {
!     if ((s = (struct zlist far **)malloc(n*sizeof(struct zlist far *))) ==
!         NULL)
        return ZE_MEM;
      n = 0;
!     for (z = zfiles; z != NULL; z = z->nxt) {
!       if (z->mark && z->nam > 0 && z->zname[z->nam - 1] == '/'
!           && (n == 0 || strcmp(z->zname, s[n-1]->zname) != 0)) {
!         s[n++] = z;
!       }
      }
      /* Sort the files in reverse order to get subdirectories first.
       * To avoid problems with strange naming conventions as in VMS,
       * we sort on the internal names, so x/y/z will always be removed
       * before x/y. On VMS, x/y/z > x/y but [x.y.z] < [x.y]
       */
      qsort((char *)s, n, sizeof(struct zlist far *), rqcmp);
! 
!     for (i = 0; i < n; i++) {
!       char *p = s[i]->name;
!       if (*p == '\0') continue;
!       if (p[strlen(p) - 1] == '/') { /* keep VMS [x.y]z.dir;1 intact */
!         p[strlen(p) - 1] = '\0';
!       }
!       if (i == 0 || strcmp(s[i]->zname, s[i-1]->zname) != 0) {
!         if (verbose) {
            fprintf(mesg, "zip diagnostic: trashing directory %s (if empty)\n",
!                   s[i]->name);
!         }
          deletedir(s[i]->name);
        }
!     }
      free((voidp *)s);
    }
    return ZE_OK;
Only in .: zipgrep
Only in .: zipgrep.1
diff -c ../zip19i/zipnote.c ./zipnote.c
*** ../zip19i/zipnote.c	Tue Nov  3 21:07:58 1992
--- ./zipnote.c	Thu Sep  9 23:25:26 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 21,26 ****
--- 20,27 ----
  
  /* Character to mark zip entry names in the comment file */
  #define MARK '@'
+ #define MARKE " (comment above this line)"
+ #define MARKZ " (zip file comment below this line)"
  
  /* Temporary zip file name and file pointer */
  local char *tempzip;
***************
*** 34,40 ****
     local void help(void);
     local void putclean(char *, int);
     local int catalloc(char * far *, char *);
!    void main(int, char **);
  #endif /* PROTO */
  
  
--- 35,41 ----
     local void help(void);
     local void putclean(char *, int);
     local int catalloc(char * far *, char *);
!    int main(int, char **);
  #endif /* PROTO */
  
  
***************
*** 159,165 ****
      if (c == MARK || c == '\\')
        putchar('\\');
      if (c >= ' ' || c == '\t' || c == '\n')
!       putchar(e = c);
    }
    if (e != '\n')
      putchar('\n');
--- 160,166 ----
      if (c == MARK || c == '\\')
        putchar('\\');
      if (c >= ' ' || c == '\t' || c == '\n')
!       { e=c; putchar(e); }
    }
    if (e != '\n')
      putchar('\n');
***************
*** 188,194 ****
  }
  
  
! void main(argc, argv)
  int argc;               /* number of tokens in command line */
  char **argv;            /* command line tokens */
  /* Write the comments in the zipfile to stdout, or read them from stdin. */
--- 189,195 ----
  }
  
  
! int main(argc, argv)
  int argc;               /* number of tokens in command line */
  char **argv;            /* command line tokens */
  /* Write the comments in the zipfile to stdout, or read them from stdin. */
***************
*** 218,224 ****
--- 219,227 ----
    zipfile = tempzip = NULL;
    tempzf = NULL;
    signal(SIGINT, handler);
+ #ifdef SIGTERM              /* AMIGA has no SIGTERM */
    signal(SIGTERM, handler);
+ #endif
    k = w = 0;
    for (r = 1; r < argc; r++)
      if (*argv[r] == '-')
***************
*** 273,281 ****
      {
        printf("%c %s\n", MARK, z->zname);
        putclean(z->comment, z->com);
!       putchar(MARK);  putchar('\n');
      }
!     putchar(MARK);  putchar('\n');
      putclean(zcomment, zcomlen);
      exit(ZE_OK);
    }
--- 276,284 ----
      {
        printf("%c %s\n", MARK, z->zname);
        putclean(z->comment, z->com);
!       printf("%c%s\n", MARK, MARKE);
      }
!     printf("%c%s\n", MARK, MARKZ);
      putclean(zcomment, zcomlen);
      exit(ZE_OK);
    }
***************
*** 287,314 ****
    t = getfileattr(zipfile);
  
    /* Process stdin, replacing comments */
!   for (z = zfiles; z != NULL; z = z->nxt)
!   {
!     if (gets(a) == NULL || a[0] != MARK || a[1] != ' ' ||
!         strcmp(a + 2, z->zname))
!       err(ZE_NOTE, "missing entry name");
!     if (z->com)
        free((voidp *)z->comment);
      z->comment = malloc(1);  *(z->comment) = 0;
      while (gets(a) != NULL && *a != MARK)
        if ((r = catalloc(&(z->comment), a)) != ZE_OK)
          err(r, "was building new comments");
-     if (a[1])
-       err(ZE_NOTE, "missing comment end line");
      z->com = strlen(z->comment);
    }
-   if (gets(a) == NULL || a[0] != MARK || a[1])
-     err(ZE_NOTE, "missing zip file comment marker line");
-   zcomment = malloc(1);  *zcomment = 0;
-   while (gets(a) != NULL)
-     if ((r = catalloc(&zcomment, a)) != ZE_OK)
-       err(r, "was building new comments");
-   zcomlen = strlen(zcomment);
  
    /* Open output zip file for writing */
    if ((tempzf = y = fopen(tempzip = tempname(zipfile), FOPW)) == NULL)
--- 290,321 ----
    t = getfileattr(zipfile);
  
    /* Process stdin, replacing comments */
!   z = zfiles;
!   while (gets(a) != NULL && (a[0] != MARK || strcmp(a + 1, MARKZ)))
!   {                                     /* while input and not file comment */
!     if (a[0] != MARK || a[1] != ' ')    /* better be "@ name" */
!       err(ZE_NOTE, "unexpected input");
!     while (z != NULL && strcmp(a + 2, z->zname))
!       z = z->nxt;                       /* allow missing entries in order */
!     if (z == NULL)
!       err(ZE_NOTE, "unknown entry name");
!     if (z->com)                         /* change zip entry comment */
        free((voidp *)z->comment);
      z->comment = malloc(1);  *(z->comment) = 0;
      while (gets(a) != NULL && *a != MARK)
        if ((r = catalloc(&(z->comment), a)) != ZE_OK)
          err(r, "was building new comments");
      z->com = strlen(z->comment);
+     z = z->nxt;                         /* point to next entry */
+   }
+   if (a != NULL)                        /* change zip file comment */
+   {
+     zcomment = malloc(1);  *zcomment = 0;
+     while (gets(a) != NULL)
+       if ((r = catalloc(&zcomment, a)) != ZE_OK)
+         err(r, "was building new comments");
+     zcomlen = strlen(zcomment);
    }
  
    /* Open output zip file for writing */
    if ((tempzf = y = fopen(tempzip = tempname(zipfile), FOPW)) == NULL)
***************
*** 355,358 ****
--- 362,366 ----
  
    /* Done! */
    exit(ZE_OK);
+   return 0; /* avoid warning */
  }
